unit myBlock;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, Graphics;

type

  { TBlock }

  TBlock = class(TObject)
  private
  public
    travel_distance: integer;
    posY, posX, sizeX, sizeY: integer;
    r, g, b: integer;
    Color: TColor;
    rectangle: TRect;
    willMove, touched: boolean;
    procedure resetPosition;
    procedure moveRight(X: integer);
    procedure Draw(Canvas: TCanvas);
    procedure move(X, Y: integer);
    procedure mousetouch(x, y: integer);
    property isTouching: boolean read touched write touched;
    property setColor: TColor read color write color;
    constructor Create(Canvas: TCanvas);
    destructor Destroy; override;
  end;

implementation

{ TBlock }

procedure TBlock.resetPosition;
begin
  posX := 50;
  //  posy := 50;
end;

procedure TBlock.moveRight(X: integer);
begin
  travel_distance := X;
  posX := posX + travel_distance;
  rectangle := Rect(posX, posY, posX + sizeX, posY + SizeY);

end;

procedure TBlock.Draw(Canvas: TCanvas);
begin
  Canvas.Brush.Color := Color;
  canvas.FillRect(rectangle);
end;

procedure TBlock.move(X, Y: integer);
begin
  if touched then
  begin
    posX := X - sizeX div 2;
    posY := Y - sizeY div 2;
    rectangle := Rect(posX, posY, posX + sizeX, posY + SizeY);
  end;

end;

procedure TBlock.mousetouch(x, y: integer);
begin
  if rectangle.Contains(Point(X, Y)) then
  begin
    touched := True;
  end
  else
    touched := False;
end;

constructor TBlock.Create(Canvas: TCanvas);
begin
  r := 198;
  g := 100;
  b := 210;
  willMove := False;
  sizeX := 100;
  sizeY := 100;
  posX := (Canvas.Width div 2)+100;
  posY := (Canvas.Height div 2)+100;
  Color := RGBToColor(r, g, b);
  rectangle := Rect(posX, posY, posX + sizeX, posY + SizeY);

end;

destructor TBlock.Destroy;
begin
  inherited Destroy;
end;

end.
